/*

	ImagesForever 1.9
  by Thinkyhead
  December 10, 2011

*/

var start_message	= 'c l i c k  t o   b e g i n';
var error_count = 0;
var error_msg;

// current dir and home dir
var cwd, home;

// interface parts
var photo_box, image_fetching;

var app_dir, hist_dir, histfile, ban_file, search_script;
var the_word, the_url, the_link, the_file, the_page, the_safe, the_size, total_found = 0;
var img_width, img_height;
var has_image, image_saved, is_new;
var now_fetching, serial_number;
var hist_pos, hist_size;

// Prefs mirrors
var safe_search, search_size;
var save_dir;
var auto_timer;
var silent;
var auto_mode, old_auto_mode;

var sizes = new Array(0,'xxlarge','small|medium|large|xlarge','icon');

var img_back, img_fwd, img_save, img_desk, img_info, img_block, img_mode, img_color, img_reload, img_rand, img_google;

function load()
{
	init_globals();
	init_photo_boxes();
	load_preferences();

	setupParts();

	boxBlockAlert.style.display = "none";

	set_save_icon();
	set_mode_icon();
	toggle_bkgd(0);
	set_button_states();
	set_caption();

	reset_auto_timer();

	if (widget.preferenceForKey('splashPref') == 0)
		start_fetch_image();
	else
		set_photo_image(cwd+"Images/title.png", 320, 264);
 }

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
}

function showBack(event)
{
	// your widget needs to show the back

	stop_auto_timer();
	cancel_pending_fetch();
	search_completed();

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);

	reset_auto_timer();
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

//------------------------
// toggle_bkgd
//
function toggle_bkgd(add)
{
	if (add == null) add = 1;
	b = (widget.preferenceForKey('backColor') + add) % 3;
	widget.setPreferenceForKey(b, 'backColor');
	img_color.src = "Images/bak" + b + ".png";
    var colors = ['transparent','white','black'];
    imageBacking.style.backgroundColor = colors[b];
}

//------------------------
// history_size
//
function history_size()
{
	var p = escape_path(histfile);
	var cmd = 'touch '+p+'; wc -l '+p+' | awk \'{ print $1 }\'';
	var rez = widget.system(cmd, null).outputString;
	return rez;
}

//------------------------
// set_save_icon
//
function set_save_icon()
{
	img_save.src = "Images/" + (silent ? 'auto' : image_saved ? "file" : "file-un") + ".png";
}

//------------------------
// set_mode_icon
//
function set_mode_icon()
{
	var imgs = new Array('off','loop','rand');
	img_mode.src = "Images/auto-" + imgs[auto_mode] + ".png";
}

//------------------------
// set_button_states
//
function set_button_states()
{
	//
	// Toolbar and Search Line
	//
	set_again_state();

	if (now_fetching)
	{
		img_back.style.opacity = img_fwd.style.opacity = img_save.style.opacity = img_desk.style.opacity = img_info.style.opacity = img_block.style.opacity = img_reload.style.opacity = img_rand.style.opacity = img_google.style.opacity = 0.25;

		enable_mbp_buttons();
	}
	else
	{
		enable_mbp_buttons();

		img_rand.style.opacity = 1.0;
//		button_rand.onclick = "do_click_random(event);";

		img_fwd.style.opacity = (hist_pos < -1) ? 1.0 : 0.25;
		img_back.style.opacity = (hist_pos > -hist_size) ? 1.0 : 0.25;

		if (has_image)
		{
			img_save.style.opacity = (!image_saved || silent) ? 1.0 : 0.25;
			img_desk.style.opacity = img_info.style.opacity = img_block.style.opacity = img_google.style.opacity = 1.0;
		}
		else
		{
			img_save.style.opacity = img_desk.style.opacity = img_info.style.opacity = img_block.style.opacity = 0.25;
		}

	}
}

//------------------------
// set_again_state
//
function set_again_state()
{
	var state = !now_fetching && (clean(searchTerms.value) || the_word);
	img_reload.style.opacity = state ? 1.0 : 0.25;
	button_reload.disabled = state ? '' : 'disabled';
}

//------------------------
// enable_mbp_buttons
//
function enable_mbp_buttons()
{
	img_mode.style.opacity = img_color.style.opacity = 1.0;
	button_mode.disabled = button_color.disabled = '';
}

//------------------------
// start_image_fetch(term)
//
function start_fetch_image(term)
{
	searchTerms.disabled = "disabled";

	var googles = 0;
	var historical = false;
	var args;

	// fetch from the history
	if (/-\d+/.test(term))
	{
		is_new = false;
		historical = true;
		hist_pos = term * 1;
		args = '"'+hist_pos+'"';
	}
	else	// or get a new image
	{
		set_button_states();
		searchTerms.value = term ? term + '...' : '...';
		is_new = true;
		serial_number++;
		args = serial_number + ' ' + safe_search + ' ' + search_size + ' ' + escape_path(ban_file);
		if (term) args += ' ' + escape(term);
	}

	set_caption(historical ? '• • •' : ' ');
	captionText.style.color = "#609";

	if (!historical) show_progress_bar();

	image_fetching = widget.system(search_script+' '+args, finish_hook);
}

function cancel_pending_fetch()
{
	if (now_fetching) {
		image_fetching.cancel();
		image_fetching = null;
		hide_progress_bar();
	}
}

//
// finish_hook
//
function finish_hook()
{
	finish_fetch_image(this.outputString)
}

//------------------------
// finish_fetch_image
//
function finish_fetch_image(img_data, isnew)
{
	var kibble;

	reset_auto_timer();

	if (img_data && (kibble = img_data.split(' ')) && kibble.length == 12)
	{
		if (kibble[0] == serial_number || kibble[0] == 'x')
		{
			if (kibble[0] == serial_number) hist_pos = -1;		// a new image, thus the latest

			// Display the number of Google hits it took to get here
//			alert("Image found in " + kibble[1] + " Google" + (kibble[1] != 1 ? 's' : '') + "!");

			total_found = kibble[2]*1;	
			the_word	= unescape(kibble[3]);
			the_safe	= kibble[4]*1;
			the_size	= kibble[5]*1;
			the_page	= kibble[6]*1;
			the_url		= kibble[7];
			the_link	= kibble[8];
			img_width	= kibble[9]*1;
			img_height	= kibble[10]*1;
			the_file	= hist_dir + "/" + kibble[11];

			set_photo_image(the_file, img_width, img_height);

			var the_site = the_link.split('/');

			var part = the_url.split('/');
			var fn = part[part.length-1];
			button_info.title = "Source Site: " + the_site[0] + "\rFile Name: "+fn+"\rDimensions: " + img_width + " x " + img_height;
			textInfoName.innerText = fn;
			textInfoSize.innerText = img_width + " x " + img_height;
			textInfoSite.innerHTML = '<a href="http://"'+part[0]+'>'+part[0]+"</a>";

			textBlock.innerHTML = "Would you like to block this image from future search results? You can also block the search value <span style=\"color:#FF0\">\""+the_word+"\"</span>.";

			has_image = true;
			image_saved = false;

			if (silent) { if (is_new) save_image(); } else set_save_icon();
		}

		hist_size = history_size();
		search_completed();
	}
	else
	{
		search_completed();
		error_message(img_data ? '• ' + img_data + ' •' : "• connect fail •")
	}
}

function search_completed()
{
	hide_progress_bar();

	if (the_word) {
		searchTerms.value = the_word;
		set_caption(the_word + " (" + total_found + ")");
	} else {
		searchTerms.value = '';
		set_caption();
	}

	searchTerms.disabled = '';
	searchTerms.selectionStart = searchTerms.selectionEnd = searchTerms.value.length;
	set_button_states();

	searchTerms.focus();
}

//------------------------
// do_content_click
//
function do_content_click(act, sub_word)
{
	if (!has_image) act = "New Random Word";
	w = clean(sub_word ? sub_word : the_word);

	switch (act)
	{
		case "New Random Word":
			do_click_random(null);
			break;

		case "Google Image Search":
			//
			// Image sizes:
			//
			// On Google, small|medium are both medium
			//
			// TYPE			MIN SIZE				MAX SIZE
			// icon			    n/a					  2,500   ( 50 x  50)
			// small		  2,501					 10,200   (102 x 100)
			// medium		 11,500   ( 115 x 100)	 90,880   (320 x 284)
			// large		 90,881 > ( 320 x 284)	479,999 < (800 x 600)
			// xlarge		480,000   ( 800 x 600)	786,431 < (1024 x 768)
			// xxlarge		786,432   (1024 x 768)	    n/a
			//
			widget.openURL("http://images.google.com/images?filter=0&start=" +the_page+ "&q="+w + (the_safe?'':'&safe=off') +(the_size?'&imgsz='+sizes[the_size]:''));
			break;

		case "Google Web Search":
			widget.openURL("http://www.google.com/search?q=" + w);
			break;

		case "Wikipedia Search":
			widget.openURL("http://en.wikipedia.com/wiki/Special:Search?search=" + clean_url(w));
			break;

		case "Everything2 Lookup":
			widget.openURL("http://everything2.com/index.pl?node=" + clean_url(w));
			break;

		case "Dictionary Lookup":
			widget.openURL("http://dictionary.reference.com/search?q=" + clean_url(w));
			break;

		case "Thesaurus Lookup":
			widget.openURL("http://thesaurus.reference.com/search?q=" + clean_url(w));
			break;

		case "Source Website":
			widget.openURL("http://" + the_link);
			break;

		case "Source Image":
			widget.openURL("http://" + the_url);
			break;
	}
}

//------------------------
// save_image
//
function save_image(always)
{
	if (has_image)
	{
		var save_mode = always ? '' : widget.preferenceForKey('saveMode');

		var ext = file_extension(the_file);	
		var num = '';
		var save_file;
		do {
			save_file = the_word + num + '.' + ext;
			var cmd = 'test -f ' + escape_path(save_dir+'/'+clean_filename(save_file));
			exists = widget.system(cmd, null).status;
			num++;
		} while (exists=='0');

		esc_save = install_image(save_file)
		image_saved = true;
		set_save_icon();
	}

	return esc_save;
}

//------------------------
// install_image
//
function install_image(fname, path)
{
	var esc_save = escape_path((path ? path : save_dir)+'/'+clean_filename(fname));
	widget.system('cp '+escape_path(the_file)+' '+esc_save, null);
	return esc_save;
}


function set_photo_image(name, ww, hh)
{
	photo_box.hide();

	var img = document.createElement("img");
	img.src = "file://"+name;
	if (ww) imageCanvas.width = img.width = ww;
	if (hh) imageCanvas.height = img.height = hh;

	photo_box.setImage(img);
	photo_box.show();
}

function init_globals()
{
	cwd				= widget.system("/bin/pwd", null).outputString.replace(/[\r\n]/,'') + "/";
	home			= widget.system("cd ~; /bin/pwd", null).outputString.replace(/[\r\n]/,'');
	search_script	= escape_path(cwd+'fetch_random_image.pl');
	app_dir			= home+"/Library/Application Support/ImagesForever";
	ban_file		= app_dir+'/banlist.txt';
	hist_dir		= app_dir+"/Cache";
	histfile        = hist_dir + "/.history86";
	the_word		= '';
	the_url			= "images.google.com";
	the_link		= the_url;
	the_page		= 0;
	has_image		= false;
	image_saved		= true;
	now_fetching	= false;
	hist_pos		= 0;
	hist_size		= history_size();
	serial_number	= 0;

	img_back	= document.getElementById('img_back');
	img_fwd		= document.getElementById('img_fwd');
	img_save	= document.getElementById('img_save');
	img_desk	= document.getElementById('img_desk');
	img_info	= document.getElementById('img_info');
	img_block	= document.getElementById('img_block');
	img_mode	= document.getElementById('img_mode');
	img_color	= document.getElementById('img_color');
	img_reload	= document.getElementById('img_reload');
	img_rand	= document.getElementById('img_rand');
	img_google	= document.getElementById('img_google');

	mkdir(hist_dir);
}

function init_photo_boxes()
{
	photo_box = new PhotoView(imageCanvas);
	set_photo_image(cwd + "Images/title.png");
}

//------------------------
// load_preferences
//
function load_preferences()
{
	// Initialize if they don't exist
	if (!widget.preferenceForKey('prefs98'))
	{
		widget.setPreferenceForKey(1, 'prefs98');
		widget.setPreferenceForKey(1, 'splashPref');
		widget.setPreferenceForKey(home+'/Pictures/ForeverImages', 'saveLocation');
		widget.setPreferenceForKey('Play a Sound', 'saveMode');
		widget.setPreferenceForKey(0, 'autoMode');
		widget.setPreferenceForKey(0, 'backColor');

		widget.setPreferenceForKey('Google Image Search', 'imageClick');
		widget.setPreferenceForKey('New Random Word', 'wordClick');

		widget.setPreferenceForKey(0, 'refreshTime');
		widget.setPreferenceForKey(1, 'safeSearch');
		widget.setPreferenceForKey(0, 'searchSize');
	}

	safe_search = widget.preferenceForKey('safeSearch');
	search_size = widget.preferenceForKey('searchSize');

	// Set the back side controls
	select_popup_item(popupRefresh, widget.preferenceForKey('refreshTime') + " Minutes");
	select_popup_item(popupImageClick, widget.preferenceForKey('imageClick'));
	select_popup_item(popupWordClick, widget.preferenceForKey('wordClick'));
	popupSize.selectedIndex = search_size;
	checkSafe.checked = safe_search ? 'checked' : '';

	// Save Location - currently not configurable
	save_dir = widget.preferenceForKey('saveLocation');
	mkdir(save_dir);

	// Save Behavior
	silent = widget.preferenceForKey('saveMode') == 'Silently Autosave';

	// Mode: Pause / Loop / Random
	auto_mode = widget.preferenceForKey('autoMode') * 1;
}

function reset_auto_timer(kill)
{
	stop_auto_timer();

	if (auto_mode) {
		var mins = widget.preferenceForKey('refreshTime');
		if (mins) auto_timer = setTimeout(do_auto_timer, mins * 60000);
	}
}

function stop_auto_timer()
{
	if (auto_timer) {
		clearTimeout(auto_timer);
		auto_timer = null;
	}
}

function do_auto_timer()
{
	if (!now_fetching)
		start_fetch_image(auto_mode == 1 ? the_word : '');

	auto_timer = setTimeout(do_auto_timer, widget.preferenceForKey('refreshTime') * 60000);
}


//------------------------
// show_progress_bar
//
var fade_amt;
function show_progress_bar()
{
	now_fetching = true;
	progressBar.style.background = 'url(Images/progress-bar.gif)';
	fade_amt = progressBar.style.opacity = 0;
	progressBar.style.display = 'block';
	fade_progress_bar();
}

function fade_progress_bar()
{
	if (fade_amt < 1.0) {
		fade_amt += 0.1;
		progressBar.style.opacity = fade_amt;
		setTimeout(fade_progress_bar, 20);
	}
}

//------------------------
// hide_progress_bar
//
function hide_progress_bar()
{
	now_fetching = false;
	progressBar.style.display = 'none';
}

//------------------------
// error_message
//
function error_message(err)
{
	error_msg = err ? err : "• • • error • • •";
	captionText.style.color = "#F00";
	do_error_blink(12);
}

//------------------------
// do_error_blink
//
function do_error_blink(num)
{
	if (num > 0) error_count = num;

	if (--error_count <= 0)
		set_caption(the_word ? the_word + " (" + total_found + ")" : '');
	else {
		captionText.innerText = error_count % 2 ? error_msg : '';
		setTimeout(do_error_blink, 250);
	}
}

function set_caption(text)
{
	error_count = 0;
	captionText.innerText = text ? text : start_message;
	captionText.style.color = text ? "#000" : "#900";
}


var old_opacity;
function do_click_button(event)
{
	var t = event.target;
	var result = false;

	old_opacity = t.style.opacity;

	if (old_opacity < 1.0)
		return false;

	t.style.opacity /= 2;

	switch (t.id)
	{
		case "img_back":
			result = do_click_back();
			break;

		case "img_fwd":
			result = do_click_fwd();
			break;

		case "img_save":
			do_click_save();
			break;

		case "img_desk":
			do_click_desktop();
			break;

		case "img_info":
			do_click_info();
			break;

		case "img_block":
			do_click_block();
			break;

		case "img_mode":
			do_click_mode();
			break;

		case "img_color":
			do_click_color();
			break;

		case "img_reload":
			do_click_reload();
			break;

		case "img_rand":
			do_click_random();
			break;

		case "img_google":
			do_click_google();
			break;
	}

	t.style.opacity = result ? 0.25 : old_opacity;
}


//
// go back in the history
//
function do_click_back()
{
	if (-hist_pos < hist_size)
		start_fetch_image(hist_pos - 1, true);

	return (hist_pos <= -hist_size);
}

//
// go forward in the history
//
function do_click_fwd()
{
	if (hist_pos < -1)
		start_fetch_image(hist_pos + 1, true);

	return (hist_pos >= -1);
}

function do_click_save()
{
	if (silent) {
		widget.setPreferenceForKey('Show a Dialog', 'saveMode');
		silent = false;
		set_save_icon();
		alert("Auto-Save Disabled");
	}
	else
		save_image();
}

//------------------------
// do_click_desktop
//
function do_click_desktop() 
{
	if (the_file)
	{
		widget.system('rm -f '+escape_path(app_dir)+'/desk-*', null);
		tell_finder('set desktop picture to POSIX file ' + install_image('desk-'+Math.floor(Math.random()*999999)+'.' + file_extension(the_file), app_dir));
	}
}

function do_click_info() 
{
	boxInfo.style.display = (boxInfo.style.display == "block") ? "none" : "block";
}

function do_click_block()
{
	if (boxBlockAlert.style.display == "block")
		boxBlockAlert.style.display = "none";
	else if (the_word)
		boxBlockAlert.style.display = "block";
}

function do_click_blockcancel(event) 
{
	boxBlockAlert.style.display = "none";
}

function do_click_blockterms(event)
{
	widget.system('echo "' + the_word + '" >>' + escape_path(ban_file), null);
	do_click_blockimage(event)
}

function do_click_blockimage(event)
{
	widget.system('echo "' + the_url + '" >>' + escape_path(ban_file), null);
	do_click_blockcancel(event);
}

function do_click_mode() 
{
	auto_mode = ++auto_mode % 3;
	widget.setPreferenceForKey(auto_mode, 'autoMode');
	reset_auto_timer();
 	set_mode_icon();
}

function do_click_color()
{
	toggle_bkgd(1);
}

function do_search_enter()
{
	if ('' != clean(searchTerms.value))
		do_search();
}

function do_search(force_rand)
{
	boxBlockAlert.style.display = "none";

	t = searchTerms.value = force_rand ? '' : clean(searchTerms.value);

	if (force_rand || t != '')
		start_fetch_image(t);
	else if (the_word)
		start_fetch_image(the_word);
}

function do_click_reload() 
{
	if (now_fetching) {
		cancel_pending_fetch();
		search_completed();
	}

	do_search();
}

function do_click_random() 
{
	cancel_pending_fetch();
	search_completed();
	do_search(true);
}

function do_click_google() 
{
	var d = clean(searchTerms.value);
	if (d && d != the_word) {
		do_content_click("Google Image Search", d);
		cancel_pending_fetch();
		do_search();
	}
	else {
		if (the_word)
			do_content_click("Google Image Search");
		else
			widget.openURL("http://images.google.com/");
	}
}

//------------------------
// do_click_image
//
function do_click_image(event) {
	do_content_click(widget.preferenceForKey('imageClick'));
}

//------------------------
// do_click_caption
//
function do_click_caption(event) {
	do_content_click(widget.preferenceForKey('wordClick'));
}

//------------------------
// do_click_infolink
//
function do_click_infolink(event) {
	do_content_click('Source Website');
}

function do_click_safetext(event) { checkSafe.click(); }
function do_click_safemode(event)  {
	safe_search = checkSafe.value ? 1 : 0;
	widget.setPreferenceForKey(safe_search, 'safeSearch');
}

function do_select_imagesizes(event)  {
	search_size = event.srcElement.selectedIndex;
	widget.setPreferenceForKey(search_size, 'searchSize');
}

function do_select_autorefresh(event)  {
	var t = event.srcElement.value.split(' ');
	widget.setPreferenceForKey((t[0]*1) ? t[0] : 0, 'refreshTime');
}

function do_select_imageclick(event) {
	widget.setPreferenceForKey(event.srcElement.value, 'imageClick');
}


function do_select_wordclick(event) {
	widget.setPreferenceForKey(event.srcElement.value, 'wordClick');
}


//------------------------
// do_click_thinky
// The most important function
function do_click_thinky(event) {
	widget.openURL("http://www.thinkyhead.com/widgets/imagesforever");
}


function select_popup_item(pop, text)
{
	var i;
	for(i=0; i<pop.length; i++)
		if (pop.options[i].text == text) {
			pop.selectedIndex = i;
			break;
		}
}

//------------------------
// clean_filename
//
function clean_filename(fn)
{
	return fn.replace(/\//, '-');
}

//------------------------
// file_extension
//
function file_extension(fn)
{
	var seg = fn.toLowerCase().split('.');
	return seg.length ? seg[seg.length-1] : '';
}

//------------------------
// tell_finder
//
function tell_finder(do_this)
{
	return widget.system("/usr/bin/osascript -e 'tell application \"Finder\" to " + do_this + "'", null).outputString;
}

//------------------------
// mkdir
//
function mkdir(dir)
{
	widget.system('mkdir -p '+escape_path(dir), null);
}

//------------------------
// clean
//
function clean(str)
{
	return str.replace(/\s\s+/g, ' ').replace(/^\s+|\s+$/g, '');
}

//------------------------
// clean_url
//
function clean_url(url)
{
	return url.replace(/ /g, '+').replace(/"|"]/g, '').replace(/&/g, '%26');
}

//------------------------
// escape_path
//
function escape_path(path)
{
	return '"' + path.replace(/\\/g, '\\\\').replace(/"|"/g, '\\"') + '"';
}

